//+------------------------------------------------------------------+
//|                       double dynamic zone williams percent range |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  DimGray
#property indicator_color7  Gold
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style6  STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern string TimeFrame               = "current time frame";
extern int    AtrPeriod               = 50;
extern int    SignalPeriod            = 20;
extern int    SignalMode              = MODE_SMA;
extern int    Price                   = PRICE_CLOSE;
extern int    DzLookBackBars          = 70;
extern double DzStartBuyProbability1  = 0.20;
extern double DzStartSellProbability1 = 0.20;
extern double DzStartBuyProbability2  = 0.085;
extern double DzStartSellProbability2 = 0.085;
extern bool   Interpolate             = true;

//
//
//
//
//

double AtrBuffer[];
double bli1[];
double sli1[];
double bli2[];
double sli2[];
double zli[];
double TempBuffer[];
double buffer2[];
double alphas[];

int    timeFrame;
string IndicatorFileName;
bool   Calculatinghilo;
bool   ReturningBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
       IndicatorBuffers(8);
       SetIndexBuffer(0,AtrBuffer);
       SetIndexBuffer(1,bli1);
       SetIndexBuffer(2,sli1);
       SetIndexBuffer(3,bli2);
       SetIndexBuffer(4,sli2);
       SetIndexBuffer(5,zli);
       SetIndexBuffer(6,buffer2);
       SetIndexBuffer(7,TempBuffer);

       //
       //
       //
       //
       //
    
       IndicatorFileName = WindowExpertName();
       Calculatinghilo   = (TimeFrame=="calculatehilo"); if (ReturningBars)  return(0);
       ReturningBars     = (TimeFrame=="returnBars");    if (ReturningBars)  return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //  
        
      IndicatorShortName(timeFrameToString(timeFrame)+ " Dynamic double zone nonlag Atr ma   ("+AtrPeriod+")");
      
   return(0);
}

//
//
//
//
//

int deinit(){ return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ReturningBars)  { AtrBuffer[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //      
         
   if (Calculatinghilo || timeFrame==Period())
   {
   
   //
   //
   //
   //
   //  

   for(i=limit; i >= 0; i--)
   {
   
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer[i]=high-low;
      else
      {
      double prevclose=Close[i+1];
      TempBuffer[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
      }
      AtrBuffer[i] = iNoLagMa(iMA(TempBuffer,0,1,0,MODE_SMA,Price,i),AtrPeriod,alphas,0,i);
      
      //
      //
      //
      //
      //
      
      bli1[i] = dzBuyP (AtrBuffer, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
      sli1[i] = dzSellP(AtrBuffer, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
      bli2[i] = dzBuyP (AtrBuffer, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
      sli2[i] = dzSellP(AtrBuffer, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);
      zli[i]  = dzSellP(AtrBuffer, 0.5,                     DzLookBackBars, Bars, i, 0.0001);
      
      }
      
      if (SignalPeriod>1) for(i = limit; i >=0; i--) buffer2[i] = iMAOnArray(AtrBuffer,Bars,SignalPeriod,0,SignalMode,i);
      
   return(0);
}
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      AtrBuffer[i]= iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,0,y);
      bli1[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,1,y);
      sli1[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,2,y);
      bli2[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,3,y);
      sli2[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,4,y);
      zli[i]      = iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,5,y);
      buffer2[i]  = iCustom(NULL,timeFrame,IndicatorFileName,"calculatehilo",AtrPeriod,SignalPeriod,SignalMode,Price,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,6,y);
      
      //
      //
      //
      //
      //
      
      if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
            for(int k = 1; k < n; k++)
            {
               AtrBuffer[i+k] = k*factor*AtrBuffer[i+n] + (1.0-k*factor)*AtrBuffer[i];
               bli1[i+k]      = k*factor*bli1[i+n]      + (1.0-k*factor)*bli1[i];
               sli1[i+k]      = k*factor*sli1[i+n]      + (1.0-k*factor)*sli1[i];
               bli2[i+k]      = k*factor*bli2[i+n]      + (1.0-k*factor)*bli2[i];
               sli2[i+k]      = k*factor*sli2[i+n]      + (1.0-k*factor)*sli2[i];
               zli[i+k]       = k*factor*zli[i+n]       + (1.0-k*factor)*zli[i];
               buffer2[i+k]   = k*factor*buffer2[i+n]   + (1.0-k*factor)*buffer2[i];
               
            }
   }  
       
   //
   //
   //
   //
   //
   
   return(0);
}

//
//
//
//
//

double values[][3];
double prices[][1];

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


